From LAAKSONEN@CSC.FI  Thu Feb 14 22:18:09 1991
Received: from router by geeni.bio.vtt.fi (5.52/1.1.geeni)
	id AA04393; Thu, 14 Feb 91 22:18:09 GMT
Received: from CSC.FI by router.funet.fi; Thu, 14 Feb 91 22:14 EET
Date: Thu, 14 Feb 91 22:10 EET
From: "Leif Laaksonen, Phone: 358-0-4565105" <LAAKSONEN@CSC.FI>
To: laaksone@geeni.bio.vtt.fi
X-Vms-To: IN%"laaksone@geeni.bio.vtt.fi"
Message-Id: <BC2ED77FB29F20B919@CSC.FI>
X-Envelope-To: laaksone@geeni.bio.vtt.fi
Status: RO

>From:	IN%"shelby!portia.stanford.edu!baroque.Stanford.EDU!jim@uunet.uu.net"  "James Helman" 14-FEB-1991 19:36:56.66
To:	info-iris@BRL.MIL
CC:	
Subj:	RE: alloca wanted! (Missing C function)

Received: from CUNYVM.BITNET by CSC.FI; Thu, 14 Feb 91 19:32 EET
Received: from CUNYVM by CUNYVM.BITNET (Mailer R2.07) with BSMTP id 0635; Tue,
 12 Feb 91 17:43:43 EST
Received: from vmb.brl.mil by CUNYVM.CUNY.EDU (IBM VM SMTP R1.2.2MX) with TCP;
 Tue, 12 Feb 91 17:43:41 EST
Received: from vmb.brl.mil by VMB.BRL.MIL id aa10508; 12 Feb 91 16:40 EST
Received: from vgr.brl.mil by VMB.BRL.MIL id aa10476; 12 Feb 91 16:32 EST
Received: from ucbvax.Berkeley.EDU by VGR.BRL.MIL id aa01620; 12 Feb 91 16:24
 EST
Received: by ucbvax.Berkeley.EDU (5.63/1.42) id AA04617; Tue, 12 Feb 91
 13:16:47 -0800
Received: from USENET by ucbvax.Berkeley.EDU with netnews for info-iris@brl.mil
 (info-iris@brl.mil) (contact usenet@ucbvax.Berkeley.EDU if you have questions)
Date: 12 Feb 91 17:53:12 GMT
>From: James Helman
 <shelby!portia.stanford.edu!baroque.Stanford.EDU!jim@uunet.uu.net>
Subject: RE: alloca wanted! (Missing C function)
Sender: info-iris-request@BRL.MIL
To: info-iris@BRL.MIL
Message-id: <JIM.91Feb12125312@baroque.Stanford.EDU>
Organization: Stanford University
X-Envelope-to: LAAKSONEN
References: <1991Feb12.090600.1362@urz.unibas.ch>

 
Doug Gwyn's widely distributed alloca() code follows.  STACK_DIRECTION
should be defined as -1 for 4D's.  Note that it does not actually
allocate on the caller's stack; it uses malloc() and free().
Allocated storage is not actually freed until the next call to
alloca() made by a higher caller.
 
I'm curious on this one.  alloca() provides a rather useful function.
Why wasn't it put in the ANSI C spec?
 
Jim Helman
Department of Applied Physics			Durand 012
Stanford University				FAX: (415) 725-3377
(jim@KAOS.stanford.edu) 			Work: (415) 723-9127
 
/*
	alloca -- (mostly) portable public-domain implementation -- D A Gwyn
 
	This implementation of the PWB library alloca() function,
	which is used to allocate space off the run-time stack so
	that it is automatically reclaimed upon procedure exit,
	was inspired by discussions with J. Q. Johnson of Cornell.
 
	It should work under any C implementation that uses an
	actual procedure stack (as opposed to a linked list of
	frames).  There are some preprocessor constants that can
	be defined when compiling for your specific system, for
	improved efficiency; however, the defaults should be okay.
 
	The general concept of this implementation is to keep
	track of all alloca()-allocated blocks, and reclaim any
	that are found to be deeper in the stack than the current
	invocation.  This heuristic does not reclaim storage as
	soon as it becomes invalid, but it will do so eventually.
 
	As a special case, alloca(0) reclaims storage without
	allocating any.  It is a good idea to use alloca(0) in
	your main control loop, etc. to force garbage collection.
*/
#ifndef lint
static char	SCCSid[] = "@(#)alloca.c	1.1";	/* for the "what" utility */
#endif
 
#ifdef X3J11
typedef void	*pointer;		/* generic pointer type */
#else
typedef char	*pointer;		/* generic pointer type */
#endif
 
#define	NULL	0			/* null pointer constant */
 
extern void	free();
extern pointer	malloc();
 
/*
	Define STACK_DIRECTION if you know the direction of stack
	growth for your system; otherwise it will be automatically
	deduced at run-time.
 
	STACK_DIRECTION > 0 => grows toward higher addresses
	STACK_DIRECTION < 0 => grows toward lower addresses
	STACK_DIRECTION = 0 => direction of growth unknown
*/
 
#ifndef STACK_DIRECTION
#define	STACK_DIRECTION	0		/* direction unknown */
#endif
 
#if STACK_DIRECTION != 0
 
#define	STACK_DIR	STACK_DIRECTION	/* known at compile-time */
 
#else	/* STACK_DIRECTION == 0; need run-time code */
 
static int	stack_dir;		/* 1 or -1 once known */
#define	STACK_DIR	stack_dir
 
static void
find_stack_direction (/* void */)
{
  static char	*addr = NULL;	/* address of first
				   `dummy', once known */
  auto char	dummy;		/* to get stack address */
 
  if (addr == NULL)
    {				/* initial entry */
      addr = &dummy;
 
      find_stack_direction ();	/* recurse once */
    }
  else				/* second entry */
    if (&dummy > addr)
      stack_dir = 1;		/* stack grew upward */
    else
      stack_dir = -1;		/* stack grew downward */
}
 
#endif	/* STACK_DIRECTION == 0 */
 
/*
	An "alloca header" is used to:
	(a) chain together all alloca()ed blocks;
	(b) keep track of stack depth.
 
	It is very important that sizeof(header) agree with malloc()
	alignment chunk size.  The following default should work okay.
*/
 
#ifndef	ALIGN_SIZE
#define	ALIGN_SIZE	sizeof(double)
#endif
 
typedef union hdr
{
  char	align[ALIGN_SIZE];	/* to force sizeof(header) */
  struct
    {
      union hdr *next;		/* for chaining headers */
      char *deep;		/* for stack depth measure */
    } h;
} header;
 
/*
	alloca( size ) returns a pointer to at least `size' bytes of
	storage which will be automatically reclaimed upon exit from
	the procedure that called alloca().  Originally, this space
	was supposed to be taken from the current stack frame of the
	caller, but that method cannot be made to work for some
	implementations of C, for example under Gould's UTX/32.
*/
 
static header *last_alloca_header = NULL; /* -> last alloca header */
 
pointer
alloca (size)			/* returns pointer to storage */
     unsigned	size;		/* # bytes to allocate */
{
  auto char	probe;		/* probes stack depth: */
  register char	*depth = &probe;
 
#if STACK_DIRECTION == 0
  if (STACK_DIR == 0)		/* unknown growth direction */
    find_stack_direction ();
#endif
 
				/* Reclaim garbage, defined as all alloca()ed storage that
				   was allocated from deeper in the stack than currently. */
 
  {
    register header	*hp;	/* traverses linked list */
 
    for (hp = last_alloca_header; hp != NULL;)
      if (STACK_DIR > 0 && hp->h.deep > depth
	  || STACK_DIR < 0 && hp->h.deep < depth)
	{
	  register header	*np = hp->h.next;
 
	  free ((pointer) hp);	/* collect garbage */
 
	  hp = np;		/* -> next header */
	}
      else
	break;			/* rest are not deeper */
 
    last_alloca_header = hp;	/* -> last valid storage */
  }
 
  if (size == 0)
    return NULL;		/* no allocation required */
 
  /* Allocate combined header + user data storage. */
 
  {
    register pointer	new = malloc (sizeof (header) + size);
    /* address of header */
 
    ((header *)new)->h.next = last_alloca_header;
    ((header *)new)->h.deep = depth;
 
    last_alloca_header = (header *)new;
 
    /* User storage begins just after header. */
 
    return (pointer)((char *)new + sizeof(header));
  }
}

